package org.fuseri.model.dto.certificate;

import jakarta.validation.Valid;
import jakarta.validation.constraints.NotNull;
import lombok.Getter;
import lombok.Setter;
import org.fuseri.model.dto.course.CourseDto;
import org.fuseri.model.dto.user.UserDto;


/**
 * This class represents a Data Transfer Object (DTO) for creating Certificate entities.
 * It is used for creating Certificate entity.
 */
@Getter
@Setter
public class CertificateCreateDto {
    @NotNull
    @Valid
    private UserDto user;
    @NotNull
    @Valid
    private CourseDto course;

    public CertificateCreateDto(UserDto user, CourseDto course) {
        this.user = user;
        this.course = course;
    }
}
