package org.fuseri.modulelanguageschool.lecture;

import jakarta.persistence.Entity;
import jakarta.persistence.ManyToMany;
import jakarta.persistence.ManyToOne;
import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;
import org.fuseri.modulelanguageschool.common.DomainObject;
import org.fuseri.modulelanguageschool.course.Course;
import org.fuseri.modulelanguageschool.user.User;

import java.time.LocalDateTime;
import java.util.List;

/**
 * This class represents a lecture entity in the domain model.
 */
@Getter
@Setter
@NoArgsConstructor
@AllArgsConstructor
public class Lecture extends DomainObject {

    private LocalDateTime from;
    private LocalDateTime to;
    private String topic;

    private Course course;

    private User lecturer;

    private List<User> user;
}
