package org.fuseri.modulelanguageschool.user;

import org.fuseri.modulelanguageschool.common.DomainObject;
import jakarta.persistence.*;
import lombok.*;
import org.fuseri.modulelanguageschool.course.Course;
import org.fuseri.modulelanguageschool.course.Language;
import org.fuseri.modulelanguageschool.course.ProficiencyLevel;

import java.util.List;

@Getter
@Setter
@Entity
@Builder
@NoArgsConstructor
@AllArgsConstructor
@Table(name = "domain_user")
public class User extends DomainObject {

    private String username;

    @Enumerated(EnumType.STRING)
    private UserType userType;

    private String password;

    private String email;

    private String firstName;

    private String lastName;

    @Embedded
    private Address address;
    private List<Language> languages;
    private List<ProficiencyLevel> proficiencyLevels;
}
