package org.fuseri.modulelanguageschool.user;

import org.fuseri.model.dto.common.Result;
import org.fuseri.model.dto.user.AddressDto;
import org.fuseri.model.dto.user.UserAddLanguageDto;
import org.fuseri.model.dto.user.UserCreateDto;
import org.fuseri.model.dto.user.UserDto;
import org.fuseri.model.dto.user.UserLoginDto;
import org.fuseri.modulelanguageschool.course.Course;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import jakarta.validation.Valid;
import jakarta.validation.constraints.PositiveOrZero;


import java.util.ArrayList;
import java.util.List;

@RestController
@RequestMapping("/users")
public class UserController {

    private final UserService service;

    private final UserMapper mapper;

    @Autowired
    public UserController(UserService service/*, UserMapper mapper*/) {
        this.service = service;
        this.mapper = null;
    }

    @GetMapping("/{id}")
    public UserDto find(@PathVariable String id) {
        return new UserDto("spracher","spracher@gmail.com","Sprach","MeNot",new AddressDto());
    }

    @PostMapping
    public UserDto create(@Valid @RequestBody UserCreateDto dto) {
        return new UserDto(dto.getUsername(),dto.getEmail(),dto.getFirstName(),dto.getLastName(),dto.getAddress());
    }

    @DeleteMapping("/{id}")
    public UserDto deleteUser(@PathVariable String id) {
        return new UserDto("spracher","spracher@gmail.com","Sprach","MeNot",new AddressDto());
    }

    @PutMapping("/update/{id}")
    public UserDto update(@PositiveOrZero @PathVariable String id,@Valid @RequestBody UserCreateDto user) {

        return new UserDto(user.getUsername(),user.getEmail(),user.getFirstName(),user.getLastName(),user.getAddress());
    }

    @GetMapping("/all")
    public Result<UserDto> findAll(@PositiveOrZero @RequestParam int page) {
        var res = new Result<UserDto>();
        res.setItems(List.of(new UserDto("spracher","spracher@gmail.com","Sprach","MeNot",new AddressDto())
));

        return res;

    }

    @PostMapping("/login")
    public String login(@Valid @RequestBody UserLoginDto dto) {
        return String.format("User %s has spawned", dto.getUsername());
    }


    @PostMapping("/logout/{id}")
    public String logout(@PathVariable String id) {
        return "user has logged out";
    }

    @GetMapping("/finished/{id}")
    public List<Course> getFinished(@PathVariable String id) {
        return new ArrayList<>();
    }

    @GetMapping("/enrolled/{id}")
    public List<Course> getEnrolled(@PathVariable String id) {
        return new ArrayList<>();
    }

    @PutMapping("/addLanguage/{id}")
    public String  addLanguage(@PathVariable String id,@Valid @RequestBody UserAddLanguageDto body) {
        return "added Absolutely Nothing successfully!";
    }

}
