package org.fuseri.modulelanguageschool.user;

import org.fuseri.modulelanguageschool.common.DomainService;
import jakarta.persistence.EntityNotFoundException;
import lombok.Getter;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

@Service
public class UserService extends DomainService<User> {

    @Getter
    private final UserRepository repository;

    @Autowired
    public UserService(UserRepository repository) {
        this.repository = repository;
    }

    @Transactional(readOnly = true)
    public User find(String id) {
        return repository.findById(id)
                .orElseThrow(() -> new EntityNotFoundException("User '" + id + "' not found."));
    }

}
